# Axii Changelog

## Releases 22.08.*

### Release [22.08.4.0](https://gitlab.com/ArmarX/meta/setup/-/releases/22.08.4.0)

**Notes**:

- From this release on, the versioning changed
- Main releases now are `YY.MM.r.0`, where `r` is the release number
- Patch/hotfix releases now are `YY.MM.r.p`, where `p` is the patch number for the release `r`.

**Update procedure**:

- `axii self update`
- Again, make sure that you are on the stable release channel: `axii self change-release stable`

**Features**:

- Allow overriding module definitions in workspace global config (!268)

**Modules**:

- `deps/azure-kinect/body-tracking`: Export environment variables to denote location of body tracking model files (!271)
- `deps/rc_genicam_api`: Export required environment variables used in runtime (!270)
- `deps/manif`: Fix path to project's CMake config file (!272)
- `armarx_integration/object_tracking/dlr_trackers`: Add missing dependencies (!267)
- `h2t/research_projects/robdekon/robdekon`: Update dependencies (!273)
- `h2t/research_projects/jubot/activity_recognition`: New module for Jubot Action Reccognition (!275)
- `armarx_integration/robots/armarde/skills`: Enable Azure Kinect body tracking SDK for ARMAR-DE (!276)
- `h2t/code_style`: Update code style standards, get rid of old files (!281)
- `h2t/human_aware_navigation/teb_extension`: Setting teb_extension_PATH (!282)
- `deps/{ccd,doctest,fcl,range-v3}`: Explicitly setting checkout ref, bump range-v3 version from 0.11 to 0.12 (!283)
- `h2t/research_projects/robdekon`: ROBDEKON package uses now the new robot_placement module instead of mobile_manipulation (!284)

**Fixes**:

- *None*

### Release [22.08.3](https://gitlab.com/ArmarX/meta/setup/-/releases/22.08.3)

**Notes**:

- This is a patch release

Hotfix to correctly handle created_directory vs. extract_into in update step with archives.

### Release [22.08.2](https://gitlab.com/ArmarX/meta/setup/-/releases/22.08.2)

**Update procedure**:

- `axii self update`
- New stable release channel was introduced, please switch to it as follows:
  - `axii self change-release stable`
  - Directly after the Axii update, you will be on the unstable channel of Axii due to the changes. The reason is that we switched the underlying branch names for development convenience reasons. You might see warnings about it directly after updating. Executing `axii self change-release stable` transitions you to Axii's stable release, which is the default you should use and which should be used on the robots.
- If you experience errors while CMaking caffe (`The dependency target "pycaffe" of target "pytest" does not exist.`):
  - Within your active workspace, remove caffe: `rm -rf "$deps__openpose__caffe_custom__PATH"`
  - Upgrade again: `axii workspace upgrade`

**Features**:

- Allow registering executables that will be auto-generated by Axii and can prepare a specific environment (!172, !253, !254)
- Minor updates to our code formatting configurations (!205, !227, !231)
- New stable release channel for more save and convenient defaults (!226)
- Executables for module authors to simplify common problems in setup bash scripts (!257)
- Allow depending on multiple packages to provide a feature in a module definition (!222)
- `archive` update step now allows to define extract target name and if archive must be set executable (.run) (!258)

**Modules**:

- New `tools/qtcreator/*`: QtCreator (5.0.3: `tools/qtcreator/5.0`, 6.0.2: `tools/qtcreator/6.0`, 7.0.2: `tools/qtcreator/7.0`, and 8.0.0: `tools/qtcreator/8.0`) (!229, !235, !255, !262)
- New `tools/pycharm/*`: PyCharm 2022.2 (CE: `tools/pycharm/community/2022.2` and P: `tools/pycharm/professional/2022.2`) (!234)
- New `tools/clang+llvm/14.0`: LLVM + Clang 14 (!225, !239, !256, !261)
- New `tools/smt_management`: SMT management module for RT PCs (!216, !239)
- New `deps/opencv-4`: OpenCV 4 (!218, !247)
- New `deps/dlr_3d_object_tracking/ICG`: DLR ICG (3D Object Tracking) (!219, !224, !246)
- New `armarx_integration/robots/armar*/*_pcs/*`Internal PC modules for ARMAR-6 (!248) and ARMAR-7 (!245)
- New `deps/azure-kinect/body-tracking` for Microsoft Azure Kinect Body Tracking SDK (requestable as feature `azure-kinect-body-tracking` from VisionX) (!263)
- Renamed `tools/git/2.35.1` to `tools/git/2.35` (!259)
- Renamed `apt/vtk6` to `apt/vtk`, installing vtk6 on Ubuntu 18.04 and vtk7 on Ubuntu 20.04 (!236, #154)
- Removed `deps/mathlib`: Use `deps/epfl-dynamical-system/ds-adaptor` instead (!244)
- `tools/cmake/3.21`: Declare executables (!252, !260 )
- `deps/cartographer`: Fix issue with Cartographer in CMake (!238, !240)
- `deps/rc_genicam_api`: Fix RC_GENICAM CMake config dir (!250)
- `deps/manif`: Fix manif CMake config dir (!251)
- `armarx/VisionX`, feature `roboception`: Roboception Genicam is now a feature of VisionX (!241)
- `armarx/skills/control`, feature `mplib`: Add feature to build MPLib-dependent controllers (!242)
- `armarx/skills/control`, feature `mathlib`: Add feature to build EPFL mathlib-dependent controllers (!249)
- `h2t/PriorKnowledgeData.json`: Declare all components as a feature of prior knowledge data (!203)
- `deps/opencv-3/main` and `deps/openpose/caffe_custom`: Explicitly set OpenCV for caffe, fixing errors on Ubuntu 20.04 (!237, #131, #155)

**Fixes**:

- An `axii w upgrade` will honour step exclusion steps again (`--no-*`) (!232, #139)
- Fix `MODULE_*` environment variables for global module (!233, #152)
- Use environment variables instead of trying to deduce script path (!230)
- Removed deprecated commands (!228)

### Release [22.08.1](https://gitlab.com/ArmarX/meta/setup/-/releases/22.08.1)

**Update procedure**:

- `axii self update`
- Because of severe issues with PCL (!206, !208, !210, #135) we rolled back to use the apt version of PCL. Therefore, you have to trigger a full rebuild:
  - `axii workspace clean`
  - `axii workspace upgrade`

**Features**:

- Deprecated CLI commands are now dysfunctional, you should disable them via `axii config --global disable_deprecated_commands true` (!214)

**Modules**:

- Protobuf as dedicated module (dependency of Caffe/OpenPose/Cartographer) (!193)
- Mobile manipulation as ArmarX skill (!200)
- Human-aware navigation modules, make human-aware-navigation a feature of navigation (!201)
- Fix project name for mobile manipulation (!202)
- Hotfix for severe issues with PCL (!206, !208, !210, #135)

**Fixes**:

- Fix undeclared libraries in several new modules which lead to severe run-time issues (!199)
- Introduce `_AXII_DISABLE_PROMPTS` environment variable to disable prompts (!204)
- Fix runtime exceptions in `axii workspace remove` (module name not found, auto-completion) (!192)
- Code cleanup (!194)
- Fix entry point in `pyproject.toml` (!207)
- Documentation updates (!197, !198, !207)

## Releases 22.07.*

### Release [22.07.1](https://gitlab.com/ArmarX/meta/setup/-/releases/22.07.1)

**Update procedure**:

In this release, Axii's internal installation was rewritten, which means that once you self update Axii you should at least resource your bashrc/zshrc or even better just close all terminals after self-updating:

- `axii self update`
- Close all terminals and re-open them
- It is recommended to re-generate your workspace environment file for each workspace: `axii w env`

Because we now build several dependencies from source, you also need to clean your entire workspace and re-build:

- `axii w clean`

Also note the [update instructions from release 22.06.1](https://gitlab.com/ArmarX/meta/setup/-/releases/22.06.1) if you encounter any problems.

**Features**:

- CLI API overhaul (!170)
  - The subcommands of Axii were getting ambiguous due to missing scopes and therefore needed a redesign
  - The old subcommands are now deprecated, but still available and usable, they will output a warning though
  - Deprecation plan:
    - 15.7.: Deprecation, old commands still work but suggest the new commands instead
    - 22.7.: Deprecation, old commands will cease to work and suggest the new commands instead
    - 29.7.: Complete removal of old commands
  - Deprecated commands can immediately be disabled using `axii config --global disable_deprecated_commands true`
- Support variations of a module config depending on different operating systems (or versions thereof) (!178)
- Introduce script `_axii_fast_config` as a fast way to read Axii's config files (!169)
- Documentation updates and minor refactorings (!169)
- Add `ignore_patterns` option to `update` / `git` step: A list of ignore patterns which are added to the repository-local file `.git/info/exclude` during the update step (if required). (!173)
- Add flags to `install` similar to `prepare` or `build` (original contribution: !177, reimplemented in !180)

**Modules**:
- PCL source module now ignores `build/` using `ignore_patterns` (!173)
- Replace several h2t-apt-packages with Axii modules to build from source (!175)
  - This requires you to make a clean rebuild: `axii w clean; axii w upgrade`
- Added new modules: OpenPose 1.5.1 + custom Caffe (!171, !182, !185), manif (!179)
- Add OpenPose as required feature for ARMAR-6 Skills, ARMAR-DE Skills, ARMAR-7 Skills (!186)
- Add armarx::manipulation as dependency of ARMAR-6 Skills (!189)
- Add modules for PARSE by Sebastian Weigelt (!190)

**Fixes**:

- Fix issues which Axii's auto-env-refresh, where even Python venv changes were overwritten (!187)
- Correct message saying "Requested to build ..." when running `axii prepare -t` (76c753c2)

## Releases 22.06.*

### Release [22.06.2](https://gitlab.com/ArmarX/meta/setup/-/releases/22.06.2)

**Note**:

- This is a patch release

Hotfix for issues for the function instructing on how to deal with improper Axii installations.

### Release [22.06.1](https://gitlab.com/ArmarX/meta/setup/-/releases/22.06.1)

Please carefully read the part about "Shell integration and installation" before updating Axii:

**Features**:

  - Shell integration and installation (!158).

     - Axii now has to be installed by sourcing a specific bash file. Full integration in the terminal by re-sourcing the Axii workspace file after each command. To install Axii properly, execute the following steps:

         - Self-update Axii: `axii self update`.

         - Remove all remains of Axii from your `~/.bashrc` file (or `~/.zshrc` if you're using zsh). This includes sources of `.../armarx-workspace.rc`.

         - Navigate into Axii's installation directory, execute `./bootstrap` (or `./bootstrap --zsh` if you're using zsh), and follow the displayed steps.

     - Axii can now activate any workspace using `axii activate <workspace name>`. Use `axii list-workspaces` to list all known ones. You can change the workspace names in the file `~/.config/axii/known_workspaces.json`.

     - The shell integration (also auto-completion) will now work by default, the command to activate auto-completion is now obsolete.

  - Database modules: Modules can now be database modules and claim the authority of a sub-namespace. Axii can lazy-load these database modules (!155).

**Fixes**:

  - Git and/or SSH blocking update step while cloning due to user prompts. Related to this, we now no longer need to build Git from source (!165).

  - Structural reworks, improved error handling, improved user outputs, and error handling suggestions (!163).

  - Fixed a bug where features in a workspace were not activated correctly (!156).

  - Performance improvements (!160)
